﻿#If
;;; [全角/半角]キーの設定においては、
;;; US_keyboard の状態も重要になる
;;; ZenkakuKey.ahk を参照
#If ( !( is_US_keyboard ) 
    and ( Get_key_mode( Get_key_number( Trim(A_ThisHotkey, "*") ), lang_mode ) ) )

;    sc029::  ; zenkaku
    *sc029::  ; zenkaku


            key_number := Get_key_number( Trim(A_ThisHotkey, "*") )

            output_key_setting( Get_key_mode( key_number, lang_mode )
                              , Get_key_output_text( key_number, lang_mode ) )
    return


#If ( Get_key_mode( Get_key_number( Trim(A_ThisHotkey, "*") ), lang_mode ) )

    sc001::  ; esc
    sc00F::  ; tab
    sc03A::  ; caps lock
    sc00E::  ; backspace
    sc01C::  ; enter
    LWin::
    RWin::
    space::
    sc07B:: ; 無変換
    sc079:: ; 変換
    sc070:: ; かな
    AppsKey:: ; メニュー
    Left:: ; ←
    Right:: ; →
    Up:: ; ↑
    Down:: ; ↓
    Home:: ; home
    End:: ; end
    PgUp:: ; page up
    PgDn:: ; page down
    Insert:: ; insert
    Delete:: ; delete
    PrintScreen:: ; print screen
    ScrollLock:: ; scroll lock
    Pause::  ; pause
    *sc001::  ; esc
    *sc00F::  ; tab
    *sc03A::  ; caps lock
    *sc00E::  ; backspace
    *sc01C::  ; enter
    *LWin:: 
    *RWin:: 
    *space::  ; space
    *sc07B:: ; 無変換
    *sc079:: ; 変換
    *sc070:: ; かな
    *AppsKey:: ; メニュー
    *Left:: ; ←
    *Right:: ; →
    *Up:: ; ↑
    *Down:: ; ↓
    *Home:: ; home
    *End:: ; end
    *PgUp:: ; page up
    *PgDn:: ; page down
    *Insert:: ; insert
    *Delete:: ; delete
    *PrintScreen:: ; print screen
    *ScrollLock:: ; scroll lock
    *Pause::  ; pause

        key_number := Get_key_number( Trim(A_ThisHotkey, "*") )

        output_key_setting( Get_key_mode( key_number, lang_mode )
                          , Get_key_output_text( key_number, lang_mode ) )
		
    return



;;; ---------------------------------------------
;;; ---------------------------------------------
;;; ---------------------------------------------


Get_key_mode( key_number, lang_mode = "en" ) {
    global

    if ( key_number ) {
        return % ( key_%key_number%_%lang_mode%_number = 1 ) ? False ; 「そのまま」を選択しているとき
                : key_%key_number%_%lang_mode%_number
    } else {
        return False
    }
}

Get_key_output_text( key_number, lang_mode = "en" ) {
    global

    return % key_%key_number%_%lang_mode%_text
}



Get_key_number( this_hotkey ) {
    return  % ( this_hotkey = "sc001" )        ? 1  ; esc
            : ( this_hotkey = "sc029" )        ? 2  ; zenkaku
            : ( this_hotkey = "sc00F" )        ? 3  ; tab
            : ( this_hotkey = "sc03A" )        ? 4  ; caps lock
            : ( this_hotkey = "sc00E" )        ? 5  ; backspace
            : ( this_hotkey = "sc01C" )        ? 6  ; enter
            : ( this_hotkey = "LWin" )         ? 7
            : ( this_hotkey = "RWin" )         ? 8
            : ( this_hotkey = "space" )        ? 9  ; space
            : ( this_hotkey = "sc07B" )        ? 10 ; 無変換
            : ( this_hotkey = "sc079" )        ? 11 ; 変換
            : ( this_hotkey = "sc070" )        ? 12 ; かな
            : ( this_hotkey = "AppsKey" )      ? 13 ; メニュー
            : ( this_hotkey = "Left" )         ? 14 ; ←
            : ( this_hotkey = "Right" )        ? 15 ; →
            : ( this_hotkey = "Up" )           ? 16 ; ↑
            : ( this_hotkey = "Down" )         ? 17 ; ↓
            : ( this_hotkey = "Home" )         ? 18 ; home
            : ( this_hotkey = "End" )          ? 19 ; end
            : ( this_hotkey = "PgUp" )         ? 20 ; page up
            : ( this_hotkey = "PgDn" )         ? 21 ; page down
            : ( this_hotkey = "Insert" )       ? 22 ; insert
            : ( this_hotkey = "Delete" )       ? 23 ; delete
            : ( this_hotkey = "PrintScreen" )  ? 24 ; print screen
            : ( this_hotkey = "ScrollLock" )   ? 25 ; scroll lock
            : ( this_hotkey = "Pause" )        ? 26 ; pause
            :  False
}


output_key_setting( the_key_function_number
                    , the_key_text
                    , p_modifier_specified = "" ) {

    ;; CapsLock とひらがなキーを強制的に押し上げる
    ;; こうしないと、このキーを押し上げてもずっと押し下げたままだと認識されてしまう
    If ( A_ThisHotkey = "*SC03A" ) {
        send("{vkF0sc03A up}")
    } else If ( A_ThisHotkey = "*SC070" ) {
        send("{vkF2sc070 up}")
    }


    if ( the_key_function_number = 5 ) { ; 直接入力にする
        IME_SET(0)
        GoSub, IME_GET
    } else if ( the_key_function_number = 6 ) { ; 日本語入力にする
        IME_SET(1)
        GoSub, IME_GET
    } else {
        str :=    ( the_key_function_number = 1) ? ""
    ;            : ( the_key_function_number = 2) ? "　"
                : ( the_key_function_number = 3) ? ""
    ;            : ( the_key_function_number = 4) ? "　"
    ;            : ( the_key_function_number = 7) ? "　"
                : ( the_key_function_number = 8) ?  conv_str_for_sending("{←}")
                : ( the_key_function_number = 9) ?  conv_str_for_sending("{→}")
                : ( the_key_function_number = 10) ?  conv_str_for_sending("{↑}")
                : ( the_key_function_number = 11) ?  conv_str_for_sending("{↓}")
    ;            : ( the_key_function_number = 12) ? "　"
                : ( the_key_function_number = 13) ? "{Home}"
                : ( the_key_function_number = 14) ? "{End}"
                : ( the_key_function_number = 15) ? "{PgUp}"
                : ( the_key_function_number = 16) ? "{PgDn}"
    ;            : ( the_key_function_number = 17) ? "　"
                : ( the_key_function_number = 18) ? "{ESC}"
                : ( the_key_function_number = 19) ?  conv_str_for_sending("{全角}")
                : ( the_key_function_number = 20) ? "{Tab}"
                : ( the_key_function_number = 21) ? "{CapsLock}"
    ;            : ( the_key_function_number = 22) ? "　"
                : ( the_key_function_number = 23) ? "{BackSpace}"
                : ( the_key_function_number = 24) ? "{Enter}"
    ;            : ( the_key_function_number = 25) ? "　"
                : ( the_key_function_number = 26) ? "{Space}"
                : ( the_key_function_number = 27) ?  conv_str_for_sending("{無変換}")
                : ( the_key_function_number = 28) ?  conv_str_for_sending("{変換}")
                : ( the_key_function_number = 29) ?  conv_str_for_sending("{ひらがな}")
                : ( the_key_function_number = 30) ?  conv_str_for_sending("{メニュー}")
    ;            : ( the_key_function_number = 31) ? "　"
                : ( the_key_function_number = 32) ? "{Insert}"
                : ( the_key_function_number = 33) ? "{Delete}"
    ;            : ( the_key_function_number = 34) ? "　"
                : conv_str_for_sending(the_key_text) ; ★独自の設定"



        if ( p_modifier_specified ) {
            send( remove_sequential_strokes( p_modifier_specified . str ) )
        } else {
            send( remove_sequential_strokes( get_modified_keys_pressed_down() . str ) )
        }
    }


    return get_modified_keys_pressed_down() . str
}
